    ASM
;    ORG 7D20h
;PER	 =	0x000       
;PERH = 	0x001
get_spbrg
        bcf		INTCON,7    ; GIE=0
    	clrf PERH
    	clrf PER
		movlw	30H			; Fosc/8, 
		movwf	T1CON                 
		clrf	TMR1L
		clrf	TMR1H		; TMR1=0
		bcf		PIR1,0		; TMR1IF=0		
LL7		btfss	PORTC,7		; while rxpin=0 : wend
		BRA		LL7
		bsf		T1CON,0     ; START TMR1
LL3 	clrwdt
		btfsc 	PIR1,0		; TEST TMR1IF
		BRA		TIMEOUT		; TMR1IF=1
		btfsc 	PORTC,7     ; while rxpin=1 : wend
    	BRA 	LL3
LL4		btfsc 	PORTC,7     ; while rxpin=0
    	GoTo 	LL5
    	nop
    	nop
    	incf 	PER,F
    	clrf 	WREG		
    	ADDWFC 	PERH,F
    	BRA 	LL4         ; wend
LL5 	bcf 	STATUS,C    ; per=per>>1
    	RRCF 	PERH,F
    	RRCF 	PER,F
    	decf 	PER,F       ; per=per -1
    	movlw 	0
    	SUBWFB 	PERH,F
    	MOVFF   per, wreg   
		Return    
TIMEOUT retlw	0 	        ; EXIT ON TIMEOUT                  
    ENDASM       

