    'Device  18F252
    Symbol  Dat     =PORTB.0
    Symbol  Clk     =PORTB.1
    
    Symbol  CODO    =%00000000
    Symbol  CIDO    =%00000010
    Symbol  CIDI    =%00000011
'   MICE COMMANDS    
    Symbol  REST    =$FF
    Symbol  Resend  =$FE
    Symbol  DEFAULT =$F6
    Symbol  Disabl  =$F5
    Symbol  Enbl    =$F4
    Symbol  SetSR   =$F3
    Symbol  ReadTyp =$F2
    Symbol  SetRem  =$F0
    Symbol  SetWrap =$EE
    Symbol  ResWrap =$EC
    Symbol  ReadDat =$EB
    Symbol  SetStrM =$EA
    Symbol  StatReq =$E9
    Symbol  SetRes  =$E8
    Symbol  SetSca21=$E7
    Symbol  SetSca11=$E6
    ' MICE BUTTONS
    Symbol  LButt   =1
    Symbol  MButt   =4
    Symbol  RButt   =2
    Symbol  SFast   =25     ' HOW FAST TO INCREASE/DECREASE U, I VALUES IF THE WHEEL PUSHED
            
    'SEND_BYTE TO MICE
SEND_BYTE: 
    GIEH=0 
PARIT:
    PARITY=0
    TMP.BYTE0=DBYTE
    For I=0 To 7
    PARITY=PARITY+TMP.0
    TMP=TMP>>1
    Next I
    
    PARITY=PARITY // 2
    If PARITY =0 Then 
    PARITY =1
    Else
    PARITY=0
    EndIf
    TMP.BYTE0=DBYTE
    TMP.8=PARITY.0
RTS:
    Clk=1: Dat=1 
    TRISB=CODO
    Clk=0
    DelayUS 100
    Dat=0
    DelayUS 5
    Clk=1
    TRISB=CIDO
SEND:    
    For I=0 To 8
    While Clk=1 : Wend
    Dat=TMP.0
    TMP=TMP>>1
    While Clk=0 : Wend
    Next I
    While Clk=1 : Wend  '10TH CLOCK
    Dat=1
    While Clk=0 : Wend  
    TRISB=CIDI    
    While Clk=1 : Wend  '11 CLOCK
    While Clk=0 : Wend 
    GIEH=1
Return 
    ' GET_BYTE FROM MICE
GET_BYTE: 
    For I=0 To 10    
    While Clk=1: Wend 
    TMP.10=Dat
    TMP=TMP>>1
    While Clk=0: Wend    
    Next I
    dbyte=tmp.BYTE0
'=============================    
If cmdmode=1 Then
    Inc cnt
    Select cnt
        Case 1
        butt=dbyte & 7             ' Catch the first of 4 bytes button info
        Case 4                     ' Here dbyte=0 or scroll data 
        cnt=0
        If chargemenu>0 Then Charge
        Select butt
           Case LButt
'           cls
           Dec menu
           If menu=255 Then menu=mnuitems-1
           Case RButt
'           cls
           Inc menu
           If menu=mnuitems Then menu=0
        EndSelect  'butt
            
            dispon=1
        Select menu
            Case mnudisp             
            GoTo Exit
                
            Case mnusetu
             If dbyte=0 Then Exit
                If butt = MButt Then  
                   boost = SFast 
                   Else 
                   boost = 1 
                EndIf
                
                If dbyte > $10 Then
                dir=1
                dbyte=Abs(dbyte)
                Uset=Uset + dbyte * boost
                If Uset > 255 Then Uset=255
                Else
                dir=0
                Uset=Uset - dbyte * boost
                If Uset > 256 Then Uset=0
                EndIf 
                GoSub SET_OUT
      
            Case mnuseti
             If dbyte=0 Then Exit
                If butt = MButt Then 
                boost=SFast 
                Else boost=1
                EndIf
                
                If dbyte > $10 Then
                dir=1
                dbyte=Abs(dbyte)
                iset=iset + dbyte * boost
                If iset > 255 Then iset=255
                Else
                dir=0
                iset=iset - dbyte * boost
                If iset > 256 Then iset=0
                EndIf 
                GoSub SET_OUT
      
            Case mnupres
                dispon=0 
                Cls 
                GoTo Exit
                
            Case mnucom
            If butt=MButt Then
            GoSub Change_Baud:   
            EndIf
            
            Case mnucharge
Charge:            
'                 cls
            Select chargemenu
                Case  0 
                Print $FE, $0C
                If butt=MButt Then Print $FE, $0F : chargemenu =1          '"   CHARGE   "                             
                                                        '"Click Mid to GO"                         
                Case 1                                  '" SELECT TYPE "                       
                If butt=LButt Then curpos=curpos-4      '"SLA NiC Li   ESC"                                 
                If curpos>250 Then curpos=14 
                                                        
                If butt=RButt Then curpos=curpos+4
                If curpos>14 Then curpos=2  
                
                If butt=MButt Then 
                If curpos=esc Then 
                chargemenu=0
                Else
                chargemenu=2
                type=curpos                    
                EndIf 
                EndIf
                                     
                Case 2                                  '"Ncell CAP GO ESC"
                If butt=LButt Then curpos=curpos-4
                If curpos>250 Then curpos=14                      
                                       
                If butt=RButt Then curpos=curpos+4
                If curpos>14 Then curpos=2  
                
                If butt=MButt Then 
                If curpos=cGO Then chargemenu=3
                If curpos=ESC Then chargemenu=1
                EndIf 
                
                If dbyte=0 Then Exit 
                
                 If curpos=cNcell Then                     
                   If dbyte > $10 Then
                    dbyte=Abs(dbyte)
                    Ncell=Ncell + dbyte
                    If Ncell > 10 Then Ncell=10
                    Else
                    Ncell=Ncell - dbyte
                    If Ncell <1 Then Ncell=1
                   EndIf 
                  EndIf 
                  
                 If curpos=cCap Then                     
                   If dbyte > $10 Then
                    dbyte=Abs(dbyte)
                    Cap=Cap + dbyte/10
                    If Cap > 10 Then Cap=10
                    Else
                    Cap=Cap - dbyte/10
                    If Cap <0.1 Then Cap=0.1
                   EndIf 
                  EndIf                                                                                            

                Case 3
'                print at 1,1, " CHARGING..."
                GoSub RESET_TIME
                Print $FE,$0C
                If butt=MButt Then menu=mnudisp : chargemenu=0
                
            EndSelect   'chargemenu
            
            EndSelect  'menu      
    EndSelect   'cnt
EndIf  'cmdmode=1
Exit:
 int0if=0
Return


INIT_MOUSE:
'HRSOUT "INIT MOUSE", LF, CR
    DBYTE=REST
    GoSub SEND_BYTE
    While DBYTE<>$FA : Wend
    While DBYTE<>$AA : Wend
    While DBYTE<>0   : Wend
' SET INTELIMOUSE MODE    
    dbyte=SetSR
    GoSub SEND_BYTE
    While DBYTE<>$FA : Wend
   
    DBYTE=$C8
    GoSub SEND_BYTE
    While DBYTE<>$FA : Wend
   
    dbyte=SetSR
    GoSub SEND_BYTE
    While DBYTE<>$FA : Wend
    
    DBYTE=$64
    GoSub SEND_BYTE
    While DBYTE<>$FA : Wend
    
    dbyte=SetSR
    GoSub SEND_BYTE
    While DBYTE<>$FA : Wend

    DBYTE=$50
    GoSub SEND_BYTE
    While DBYTE<>$FA : Wend
    
    DBYTE=ReadTyp
    GoSub SEND_BYTE
    DelayMS 20
#IFNDEF  debug_ 
    While DBYTE<>3   : Wend
#ENDIF    
    ' SET RESOLUTION AND ACCELERATION
    dbyte=SetSR
    GoSub SEND_BYTE
    While DBYTE<>$FA : Wend
    
    DBYTE=10
    GoSub SEND_BYTE
    While DBYTE<>$FA : Wend
    
    dbyte=SetSca21  
    GoSub SEND_BYTE
    While DBYTE<>$FA : Wend     
    
    DBYTE=Enbl
    GoSub SEND_BYTE
    While DBYTE<>$FA : Wend    
Return
    

