	  Symbol LF=$0A
	  Symbol CR=$0D
	  Symbol HT=9
'      SYMBOL LF=$0A
	  Symbol BS=8
	  	  
'ADCON1.6  ADCON0.7.6
'<ADCS2> <ADCS1:ADCS0>
'Clock Conversion
'    0       00 FOSC/2
'    0       01 FOSC/8
'    0       10 FOSC/32
'    0       11 FRC (clock derived from the internal A/D RC oscillator)
'    1       00 FOSC/4
'    1       01 FOSC/16
'    1       10 FOSC/64
'    1       11 FRC (clock derived from the internal A/D RC oscillator)
'ADCON0.5-3
'CHS2:CHS0: Analog Channel Select bits
'bit 0 ADON: A/D On bit
      Symbol IPEN = 	RCON.7  

      Symbol GO     =   ADCON0.2
'ADCON1
'ADFM ADCS2 --- --- PCFG3 PCFG2 PCFG1 PCFG0
'ADFM 1 = Right justified.
'PCFG<3:0>
'    AN7 AN6 AN5 AN4 AN3 AN2 AN1 AN0 VREF+ VREF- C / R
'0000 A   A   A   A   A   A   A   A   VDD  VSS   8 / 0
'0001 A   A   A   A VREF+ A   A   A   AN3  VSS   7 / 1
'0010 D   D   D   A   A   A   A   A   VDD  VSS   5 / 0
'0011 D   D   D   A VREF+ A   A   A   AN3  VSS   4 / 1
'0100 D   D   D   D   A   D   A   A   VDD  VSS   3 / 0
'0101 D   D   D   D VREF+ D   A   A   AN3  VSS   2 / 1
'011x D   D   D   D   D   D   D   D            0 / 0
'1000 A   A   A   A VRF+ VRF- A   A   AN3  AN2   6 / 2
'1001 D   D   A   A   A   A   A   A   VDD  VSS   6 / 0
'1010 D   D   A   A VREF+ A   A   A   AN3  VSS   5 / 1
'1011 D   D   A   A VRF+ VRF- A   A   AN3  AN2   4 / 2
'1100 D   D   D   A VRF+ VRF- A   A   AN3  AN2   3 / 2
'1101 D   D   D   D VRF+ VRF- A   A   AN3  AN2   2 / 2
'1110 D   D   D   D   D   D   D   A   VDD  VSS   1 / 0
'1111 D   D   D   D VRF+ VRF- D   A   AN3  AN2   1 / 2
'C/R = # of analog input channels / # of A/D voltage references
	  	  
	  Symbol RBIF=      INTCON.0		' RB4:7 IF
	  Symbol INT0IF=	INTCON.1		'' INT IF
	  Symbol TMR0IF= 	INTCON.2 		' TMR0 Overflow Interrupt Flag 
	  Symbol RBIE=	    INTCON.3		' B4:B7 IE
	  Symbol INT0IE=	INTCON.4		'' INT IE
	  Symbol TMR0IE =   INTCON.5       ' TMR0 Overflow Interrupt Enable 
	  Symbol PEIE=	    INTCON.6	   ''
	  Symbol GIE = 	    INTCON.7       '' Global Interrupt Enable 
	  Symbol GIEL=		INTCON.6	   ' LOW PRIORITY ENABLE
	  Symbol GIEH = 	INTCON.7	    ' HIGH PRIORITY ENABLE
	  

	  Symbol RBPU  =   	INTCON2.7      '0 = PORTB pull-ups are enabled by individual port latch values
	  Symbol INTEDG0=   INTCON2.6	   '1 = Interrupt0 on rising edge
	  Symbol INTEDG1=   INTCON2.5      '1 = Interrupt1 on rising edge   
	  Symbol INTEDG2=   INTCON2.4      '1 = Interrupt2 on rising edge   
	  Symbol TMR0IP  =  INTCON2.2      'TMR0 Overflow Interrupt Priority bit 1=High
	  Symbol RBIP    =  INTCON2.0      'RB Port Change Interrupt Priority bit 1=High
	  
	  Symbol INT2IP  =  INTCON3.7      'INT2 External Interrupt Priority bit
	  Symbol INT1IP  =  INTCON3.6      'INT1 External Interrupt Priority bit
	  Symbol INT2IE  =  INTCON3.4
	  Symbol INT1IE  =  INTCON3.3
	  Symbol INT2IF  =  INTCON3.1
	  Symbol INT1IF  =  INTCON3.0
	  
	  Symbol PS0 = 	T0CON.0		      '' Prescaler ratio bit-0 
	  Symbol PS1 = 	T0CON.1		      '' Prescaler ratio bit-1 
	  Symbol PS2 = 	T0CON.2		      '' Prescaler ratio bit-2 	
'	  SYMBOL PSA = 	T0CON.3		      ' Prescaler Assignment (1=assigned to WDT 0=assigned to oscillator) 	
'	  SYMBOL T0CS = T0CON.5		      '' Timer0 Clock Source Select (0=Internal clock 1=External PORTB.4) 
	  
	  Symbol DC1B1 =   ccp1con.5       'DCxB1:DCxB0: PWM Duty Cycle bit1 and bit0
	  Symbol DC1B0 =   ccp1con.4
	  Symbol CCP1M3=   ccp1con.3       'CCPxM3:CCPxM0: CCPx Mode Select bits
      Symbol CCP1M2=   ccp1con.2
      Symbol CCP1M1=   ccp1con.1
      Symbol CCP1M0=   ccp1con.0
                                    '0000 = Capture/Compare/PWM disabled (resets CCPx module)
                                    '0001 = Reserved
                                    '0010 = Compare mode, toggle output on match (CCPxIF bit is set)
                                    '0011 = Reserved
                                    '0100 = Capture mode, every falling edge
                                    '0101 = Capture mode, every rising edge
                                    '0110 = Capture mode, every 4th rising edge
                                    '0111 = Capture mode, every 16th rising edge
                                    '1000 = Compare mode,
                                    'Initialize CCP pin Low, on compare match force CCP pin High (CCPIF bit is set)
                                    '1001 = Compare mode,
                                    'Initialize CCP pin High, on compare match force CCP pin Low (CCPIF bit is set)
                                    '1010 = Compare mode,
                                    'Generate software interrupt on compare match (CCPIF bit is set, CCP pin is unaffected)
                                    '1011 = Compare mode,
                                    'Trigger special event (CCPIF bit is set)
                                    '11xx = PWM mode
	    
	  Symbol PSPIF=   PIR1.7
      Symbol ADIF=    PIR1.6
      Symbol RCIF=    PIR1.5
      Symbol TXIF=    PIR1.4 
      Symbol SSPIF=   PIR1.3
      Symbol CCP1IF=  PIR1.2
      Symbol TMR2IF=  PIR1.1
      Symbol TMR1IF=  PIR1.0 			'
	  
	  Symbol TMR1ON=  T1CON.0
	  Symbol TMR1CS=  T1CON.1
	  Symbol T1SYNC=  T1CON.2
	  Symbol T1OSCEN= T1CON.3		' ENABLE XTAL ON RC1&RC2
	  Symbol T1CKPS0 = T1CON.4		' LOW BIT PRESKALER T1
	  Symbol T1CKPS1 = T1CON.5		' HIGH ----"--------- 
	  Symbol T1RD16 = T1CON.7
	  
	  Symbol TOUTPS3 =  T2CON.6     ' Timer2 Output Postscale Select bits
	  Symbol TOUTPS2 =  T2CON.5
	  Symbol TOUTPS1 =  T2CON.4
	  Symbol TOUTPS0 =  T2CON.3
	  Symbol TMR2ON  =  T2CON.2
	  Symbol T2CKPS1 =  T2CON.1     'Timer2 Clock Prescale Select bits
	  Symbol T2CKPS0 =  T2CON.0     ' 00-1, 01-4, 1X-16  
	  
	  Symbol PSPIE		PIE1.7		' PAR PORT IE
	  Symbol ADIE=	 	PIE1.6		' ADC IE
	  Symbol RCIE=		PIE1.5		' USATR RX IE
	  Symbol TXIE=		PIE1.4		' USATR TX IE
	  Symbol SSPIE=		PIE1.3		'
	  Symbol CCP1IE=	PIE1.2		'
	  Symbol TMR2IE=	PIE1.1		'
	  Symbol TMR1IE= 	PIE1.0		' 
	  
	  Symbol OERR=    RCSTA.1
	  Symbol CREN=    RCSTA.4
	  
	  Symbol BRGH=    TXSTA.2
	  
	  Symbol TIMER1 = 	TMR1L.Word

      Symbol PSPIP  = 	IPR1.7       ' Parallel Slave Port Read/Write Interrupt Priority bit
      Symbol ADIP   = 	IPR1.6       ' A/D Converter Interrupt Priority bit
      Symbol RCIP   = 	IPR1.5       ' USART Receive Interrupt Priority bit
      Symbol TXIP   = 	IPR1.4       ' USART Transmit Interrupt Priority bit
      Symbol SSPIP  = 	IPR1.3       ' Master Synchronous Serial Port Interrupt Priority bit
      Symbol CCP1IP = 	IPR1.2       ' CCP1 Interrupt Priority bit
      Symbol TMR2IP = 	IPR1.2       ' TMR2 to PR2 Match Interrupt Priority bit
      Symbol TMR1IP = 	IPR1.0
      
	  Symbol TMR3IP = 	IPR2.1
	  			
	  Symbol TMR0ON =  T0CON.7
      Symbol T08BIT =  T0CON.6	  	  ; 1 - 8bit mode 			
      Symbol T0CS   =  T0CON.5        ; 0 - INT CLOCK
	  Symbol T0SE   =  T0CON.4        ; FRONT SELECT
	  Symbol PSA    =  T0CON.3        ; 0 PRESCALLER ENABLED
	  Symbol T0PS2  =  T0CON.2        ;   1     1     1    1    0    0   0   0
	  Symbol T0PS1  =  T0CON.1        ;   1     1     0    0    1    1   0   0
	  Symbol T0PS0  =  T0CON.0        ;   1=256 0=128 1=64 0=32 1=16 0=8 1=4 0=2
	  
	  
	  
	  
	  
